Bug 1248935 (CVE-2009-5147, CVE-2015-7551)

Summary: CVE-2009-5147 CVE-2015-7551 ruby: DL::dlopen could open a library with tainted library name
Product: [Other] Security Response Reporter: Adam Mariš <amaris>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED WONTFIX QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: apatters, bkearney, cbillett, ccoleman, cpelland, dajohnso, dclarizi, dmcphers, gblomqui, gmccullo, gtanzill, hhorak, jfrey, jhardy, jialiu, joelsmith, jokerman, jorton, jprause, jrafanie, jrusnack, jstribny, katello-bugs, kseifried, lmeyer, mmaslano, mmccomas, mmorsi, mtasaka, obarenbo, roliveri, ruby-maint, s, tagoh, tomckay, vanmeeuwen+fedora, vondruch, xlecauch
Target Milestone: ---Keywords: Reopened, Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: ruby 2.0.0-p648, ruby 2.1.8, ruby 2.2.4 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-08-10 05:04:14 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1248937, 1249697, 1534937, 1534941    
Bug Blocks: 1248954    

Description Adam Mariš 2015-07-31 07:44:21 UTC
DL::dlopen could open a library with tainted library name even if $SAFE > 0. This vulnerability affects Ruby versions 1.8, 1.9, 2.1, 2.2.

Upstream patch:
https://github.com/ruby/ruby/commit/4600cf725a86ce31266153647ae5aa1197b1215b

Additional information and CVE assignment:

http://seclists.org/oss-sec/2015/q3/222

Comment 1 Adam Mariš 2015-07-31 07:46:24 UTC
Created ruby tracking bugs for this issue:

Affects: fedora-all [bug 1248937]

Comment 2 Vít Ondruch 2015-07-31 08:11:56 UTC
(In reply to Adam Mariš from comment #0)
> DL::dlopen could open a library with tainted library name even if $SAFE > 0.
> This vulnerability affects Ruby versions 1.8, 1.9, 2.1, 2.2.

This is hardly true, since DL was removed from Ruby 2.2:

https://github.com/ruby/ruby/commit/07308c4d30b8c5260e5366c8eed2abf054d86fe7

Comment 3 Mamoru TASAKA 2015-07-31 08:36:16 UTC
First of all, why is this CVE(-2009-5147, note "2009") reported now?
The above oss-sec report says that this is already fixed in 1.9.1-p129.

Comment 4 Adam Mariš 2015-07-31 11:45:41 UTC
Hello!

This bug is only being reported now because the CVE was assigned only two days ago. Because the flaw was patched in 2009, it got a CVE from year 2009. As Vit noted above, this probably does not affect Ruby 2.2 but we still have to look into all other versions to see if they were patched.

Comment 9 Martin Prpič 2015-12-18 13:50:14 UTC
This flaw has been re-introduced in Fiddle:

"There is an unsafe tainted string vulnerability in Fiddle and DL. This issue was originally reported and fixed with CVE-2009-5147 in DL, but reappeared after DL was reimplemented using Fiddle and libffi.

And, about DL, CVE-2009-5147 was fixed at Ruby 1.9.1, but not fixed at other branches, then rubies which bundled DL except Ruby 1.9.1 are still vulnerable."

https://www.ruby-lang.org/en/news/2015/12/16/unsafe-tainted-string-usage-in-fiddle-and-dl-cve-2015-7551/

Comment 10 Fedora Update System 2015-12-29 22:23:35 UTC
ruby-2.2.4-47.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2016-01-08 03:27:19 UTC
ruby-2.2.4-47.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 12 Andrej Nemec 2017-09-08 11:55:29 UTC
Statement:

Red Hat Product Security has rated this issue as having Low security
impact. This issue is not currently planned to be addressed in future updates. 

For additional information, refer to the Issue Severity Classification:
https://access.redhat.com/security/updates/classification/.

Comment 14 errata-xmlrpc 2018-03-26 09:42:40 UTC
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 6.7 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.3 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS

Via RHSA-2018:0583 https://access.redhat.com/errata/RHSA-2018:0583